// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import type {NextApiRequest, NextApiResponse} from "next";
import {storage} from "@/firebase";
import {withIronSessionApiRoute} from "iron-session/next";
import {sessionOptions} from "@/lib/session";
import {Group} from "@/interfaces/user";
import {Payment} from "@/interfaces/paypal";
import {deleteObject, ref} from "firebase/storage";
import client from "@/lib/mongodb";

const db = client.db(process.env.MONGODB_DB);

export default withIronSessionApiRoute(handler, sessionOptions);

async function handler(req: NextApiRequest, res: NextApiResponse) {
	if (req.method === "GET") return await get(req, res);
	if (req.method === "DELETE") return await del(req, res);
	if (req.method === "PATCH") return await patch(req, res);

	res.status(404).json(undefined);
}

async function get(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const payment = await db.collection("payments").findOne<Payment>({id});

	if (!!payment) {
		res.status(200).json(payment);
	} else {
		res.status(404).json(undefined);
	}
}

async function del(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const payment = await db.collection("payments").findOne<Payment>({id});
	if (!payment) return res.status(404).json({ok: false});

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		if (payment.commissionTransfer) await deleteObject(ref(storage, payment.commissionTransfer));
		if (payment.corporateTransfer) await deleteObject(ref(storage, payment.corporateTransfer));

		await db.collection("payments").deleteOne({id: payment.id});
		res.status(200).json({ok: true});
		return;
	}

	res.status(403).json({ok: false});
}

async function patch(req: NextApiRequest, res: NextApiResponse) {
	if (!req.session.user) {
		res.status(401).json({ok: false});
		return;
	}

	const {id} = req.query as {id: string};

	const payment = await db.collection("payments").findOne<Payment>({id});
	if (!payment) return res.status(404).json({ok: false});

	const user = req.session.user;
	if (user.type === "admin" || user.type === "developer") {
		await db.collection("payments").updateOne({id: payment.id}, {$set: req.body});

		if (req.body.isPaid) {
			const corporateID = req.body.corporate;
			await db.collection("users").updateOne({id: corporateID}, {$set: {status: "active"}});
		}
		return res.status(200).json({ok: true});
	}

	res.status(403).json({ok: false});
}
